//Bf2 Rank Mod badge powers File
//Contains all the power giving etc checking functions.

#if defined bf2_powers_included
#endinput
#endif
#define bf2_powers_included

public set_speed(id)
{
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) || freezetime ) return;
	
	new Float:speed;
	
	if ( g_imobile[id] )
	{
		speed = 100.0;
	}
	else
	{
		if ( cs_get_user_vip(id) )
		{
			//VIPs only have 1 speed no matter the weapon
			speed = 227.0;
		}
		else
		{
			new weapon = get_user_weapon(id);
			
			speed = gCSWeaponSpeed[weapon];
			
			if ( gCurrentFOV[id] <= 45 )
			{
				switch(weapon)
				{
					case CSW_SCOUT: speed = 220.0;
					case CSW_SG550, CSW_AWP, CSW_G3SG1: speed = 150.0;
				}
			}
		}
		
		new smglevel = g_PlayerBadges[id][BADGE_SMG];
		new szybkosc = get_pcvar_num(gPcvarSpeed);
		
		if ( smglevel )
		{
			speed += (smglevel * szybkosc);
			set_user_footsteps(id, 1);
		}
	}
	
	if ( speed != get_user_maxspeed(id) )
	{
		set_user_maxspeed(id, speed);
	}
}

public set_invis(id)
{
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new shotgunlevel = g_PlayerBadges[id][BADGE_SHOTGUN];
	
	if ( shotgunlevel && get_user_weapon(id) == CSW_KNIFE )
	{
		fm_set_rendering(id, kRenderFxNone, 0, 0, 0, kRenderTransTexture, gInvisAlphaValue[shotgunlevel-1]);
		g_invis[id] = true;
	}
	else
	{
		fm_set_rendering(id);
		g_invis[id] = false;
	}
}

public set_grav(id)
{
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new gravlevel = g_PlayerBadges[id][BADGE_GRAVITY];
	
	if ( gravlevel && get_user_weapon(id) == CSW_KNIFE )
	{
		new Float:grav
		switch(gravlevel)
		{
			case 1: grav = get_pcvar_float(gPcvarGrav1);
			case 2: grav = get_pcvar_float(gPcvarGrav2);
			case 3: grav = get_pcvar_float(gPcvarGrav3);
			case 4: grav = get_pcvar_float(gPcvarGrav4);
			case 5: grav = get_pcvar_float(gPcvarGrav5);
			case 6: grav = get_pcvar_float(gPcvarGrav6);
		}
		fm_set_user_gravity(id, grav)
		g_grav[id] = true;
	}
	else
	{
		fm_set_user_gravity(id, 1.0)
		g_grav[id] = false;
	}
}

public remove_imobile(id)
{
	g_imobile[id] = false;
	
	set_speed(id);
}

public give_userweapon(id)
{
	if ( !get_pcvar_num(gPcvarBadgesActive) || !get_pcvar_num(gPcvarBadgePowers) ) return;
	if ( !is_user_alive(id) ) return;
	
	new bool:givenitem = false;
	
	new assaultlevel = g_PlayerBadges[id][BADGE_ASSAULT];
	new assaulthp = get_pcvar_num(gPcvarHP);
	
	if ( assaultlevel )
	{
		new hp;
		hp = 100 + (assaultlevel * assaulthp);
		
		if ( get_user_health(id) < hp )
		{
			set_user_health(id, hp);
			
			if ( pev(id, pev_max_health) < float(hp) )
			{
				set_pev(id, pev_max_health, float(hp));
			}
			
			givenitem = true;
		}
	}
	
	new kasalevel = g_PlayerBadges[id][BADGE_KASA];
	new kasaile = get_pcvar_num(gPcvarKasa);
	new kasa = cs_get_user_money(id);
	
	if ( kasalevel )
	{
		new kasadodaj = kasa + (kasalevel * kasaile);
		
		if( cs_get_user_money(id) < 16000 )
		{		
			cs_set_user_money(id, kasadodaj);
		}
		
		givenitem = true;
	}
	
	new sniperlevel = g_PlayerBadges[id][BADGE_SNIPER];
	
	if ( sniperlevel )
	{
		if ( random_num(1, (7-sniperlevel)) == 1 )
		{
			new weaponName[32];
			new weaponID = get_user_weapon(id);
			
			if ( !get_pcvar_num(gPcvarFreeAwp) )
			{
				fm_give_item(id, "weapon_scout");
			}
			else
			{
				#if defined VIP_BF2
				if(get_user_flags(id) & ADMIN_LEVEL_H) 
				{
					fm_give_item(id, "weapon_awp");
				}
				else 
				{
					fm_give_item(id, "weapon_scout");
				}
				#else
				fm_give_item(id, "weapon_awp");
				#endif
			}
			
			if ( weaponID )
			{
				get_weaponname(weaponID, weaponName, charsmax(weaponName));
				engclient_cmd(id, weaponName);
			}
			
			givenitem = true;
		}
	}
	
	new explosionlevel = g_PlayerBadges[id][BADGE_EXPLOSIVES];
	
	if ( explosionlevel )
	{
		if ( random_num(1, (7-explosionlevel)) == 1 )
		{
			fm_give_item(id, "weapon_hegrenade");
			
			givenitem = true;
		}
	}
	
	new agentlevel = g_PlayerBadges[id][BADGE_AGENT];
	
	if( agentlevel>LEVEL_NONE )
	{
			cs_set_user_nvg(id,1)
	}
	
	new CsArmorType:ArmorType;
	new UserArmor = cs_get_user_armor(id, ArmorType);
	
	new armor1 = get_pcvar_num(gPcvarArmor1);
	new armor2 = get_pcvar_num(gPcvarArmor2);
	new armor3 = get_pcvar_num(gPcvarArmor3);
	new armor4 = get_pcvar_num(gPcvarArmor4);
	new armor5 = get_pcvar_num(gPcvarArmor5);
	new armor6 = get_pcvar_num(gPcvarArmor6);
	
	switch (numofbadges[id])
	{
		case 6 .. 15:
		{
			if ( UserArmor < armor1 )
			{
				cs_set_user_armor(id, armor1, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
		
		case 16 .. 27:
		{
			if ( UserArmor < armor2 )
			{
				cs_set_user_armor(id, armor2, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
		
		case 28 .. 38:
		{
			if ( UserArmor < armor3 )
			{
				cs_set_user_armor(id, armor3, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
		
		case 39 .. 49:
		{
			if ( UserArmor < armor4 )
			{
				cs_set_user_armor(id, armor4, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
		
		case 50 .. 60:
		{
			if ( UserArmor < armor5 )
			{
				cs_set_user_armor(id, armor5, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
		
		case 61 .. 72:
		{
			if ( UserArmor < armor6 )
			{
				cs_set_user_armor(id, armor6, CS_ARMOR_VESTHELM);
				givenitem = true;
			}
		}
	}
	
	if ( givenitem )
	{
		screen_flash(id, 0, 255, 0, 100);
	}
}